'Imports NationalInstruments.VisaNS

Public Class Form1

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        End
    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click

        REM  ##############################################
        REM  
        REM    KE2100 measure VOLTage:DC 
        REM
        REM    Using NI-VISA Visual Studio 2005 dotnet NationalInstruments.VisaNS
        REM
        REM  ##############################################

        Dim resourceList() As String
        Dim resourceName As String
        Dim strTemp As String
        Dim notFound As Boolean
        Dim timeOut As Integer
        Dim defaultRM As NationalInstruments.VisaNS.ResourceManager
        Dim vi As NationalInstruments.VisaNS.MessageBasedSession
        Dim responseString As String

        '
        ' Use the resource manager to find the KE2100 device on port "USB0"
        '
        defaultRM = NationalInstruments.VisaNS.ResourceManager.GetLocalManager()
        resourceList = defaultRM.FindResources("?*") ' Get a list of local VISA resources
        notFound = True
        resourceName = ""
        For Each strTemp In resourceList            ' Search the list
            If strTemp.Contains("USB0") Then
                notFound = False
                resourceName = strTemp
                Exit For
            End If
        Next

        If notFound Then
            MsgBox("KE2100 USB device not found.")
            Exit Sub
        End If
      
        vi = defaultRM.Open(resourceName)
        vi.Write("*RST")                        ' Reset the instrument
        vi.Write("*CLS")                        ' Clear the status
        vi.Write("SAMP:COUN 1")                 ' Setup to take only one reading
        vi.Write("SENS:VOLT:DC:RANGE:AUTO ON")  ' Turn on autorange

        timeOut = vi.Timeout
        vi.Timeout = 10000

        vi.Write("MEAS:VOLT:DC?")               ' Take a measurement
        responseString = vi.ReadString()        ' Readback the measurement
        Label1.Text = responseString            ' Display the measurement

        vi.Timeout() = timeOut
        vi.Write("system:local")                ' Send instrument back to local mode
        vi.Dispose()                            ' Close the VISA session

        MsgBox("End of measurement.", MsgBoxStyle.Information, "KE2100 Measure example")
    End Sub
End Class
